> For the complete documentation index, see [llms.txt](https://docs.carbondefi.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/composetradebysourcetransaction.md).

# composeTradeBySourceTransaction

This function creates an unsigned transaction to trade by source amount.&#x20;

```
public async composeTradeBySourceTransaction(
    sourceToken: string,
    targetToken: string,
    tradeActions: TradeActionStruct[],
    deadline: BigNumberish,
    minReturn: string,
    overrides?: PayableOverrides
  )
```

| Name         | Type                  | Description                                                                                                                                                                                                                                       |
| ------------ | --------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| sourceToken  | token address         | The token being sent.                                                                                                                                                                                                                             |
| targetToken  | token address         | The token received.                                                                                                                                                                                                                               |
| tradeActions | list                  | The list of trade actions to be performed.                                                                                                                                                                                                        |
| deadline     | number                | The timestamp at which point the trade will no longer be valid.                                                                                                                                                                                   |
| minReturn    | string                | The minimum amount of target tokens that must be received for the trade to execute.                                                                                                                                                               |
| overrides    | object (**optional**) | This optional object contains transaction parameters, such as gas price, Eth value, etc. See **overrides** in the [Ethers documentation](https://docs.ethers.org/v5/api/contract/contract/#:~:text=The-,overrides,-object%20for%20a) for details. |

### Returns

This function returns an unsigned transaction that is ready to be signed and submitted to the blockchain.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/composetradebysourcetransaction.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
